import aesJm from "./aes.js";

/**
 * AES-128 加密
 * @param {type string} hexStr 加密前的16个字节的进制字符串
 * @param {type array} keys 开锁器或者是锁的 keys 10进制数组
 * hexStr示例：06010101000000000000000000000000
 * keys示例：[20, 82, 47, 82, 54, 75, 63, 71, 48, 80, 65, 88, 17, 99, 45, 43]
 */
export const encryptionData = (hexStr, keys) => {
    if (keys === undefined) return console.error('encryptionData 方法keys必须传入');

    var byteKey = aesJm.CryptoJS.enc.int8array.parse(keys);
    var byteData = aesJm.CryptoJS.enc.Hex.parse(hexStr);
    var encrypt = aesJm.CryptoJS.AES.encrypt(byteData, byteKey, {
        mode: aesJm.CryptoJS.mode.ECB, // 加密模式
        padding: aesJm.CryptoJS.pad.NoPadding, //填充方式
        // iv: '', //偏移量
    });
    var encryptedStr = encrypt.ciphertext.toString();
    return encryptedStr;
}


/**
 * AES-128 解密
 */
export const decryptData = (hexStr, keys) => {
    if (keys === undefined) return console.error('decryptData 方法keys必须传入');

    var byteKey = aesJm.CryptoJS.enc.int8array.parse(keys);
    var byteData = aesJm.CryptoJS.enc.Hex.parse(hexStr);
    byteData = aesJm.CryptoJS.enc.Base64.stringify(byteData);
    var decrypt = aesJm.CryptoJS.AES.decrypt(byteData, byteKey, {
        mode: aesJm.CryptoJS.mode.ECB, // 加密模式
        padding: aesJm.CryptoJS.pad.NoPadding, //填充方式
        // iv: '', //偏移量
    });
    var decryptedStr = decrypt.toString(aesJm.CryptoJS.enc.Hex);
    return decryptedStr.toString();
}